// Copyright (c) 2013, the project authors. Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed 
// by a Apache license that can be found in the LICENSE file.

library handheld_sample;

//import 'package:handheld/handheld_mock.dart';
import 'package:handheld/handheld.dart';

import 'dart:html' hide DeviceAcceleration;

import 'package:route_hierarchical/client.dart';

part 'pages/accelerometer_page.dart';
part 'pages/device_page.dart';
part 'pages/main_page.dart';
part 'pages/notification_page.dart';
part 'pages/page.dart';

main() {
  handheld.onDeviceReady.then((Device device) {
    var controller = new AppController(device);
    controller.go();
  });
  //handheldReady();
}

class AppController {
  AppController(Device device) {
    // create pages
    var accelerometerPage = new AccelerometerPage(_router);
    var mainPage = new MainPage(_router);
    var devicePage = new DevicePage(_router);
    // bind routes
    _router.addHandler(new UrlPattern(r'(.*)\.html'), (_) => mainPage.show(device));
    _router.addHandler(new UrlPattern(r'(.*)main'), (_) => mainPage.show(device)); 
    _router.addHandler(new UrlPattern(r'(.*)device'), (_) => devicePage.show(device));
    _router.addHandler(new UrlPattern(r'(.*)accelerometer'), (_) => accelerometerPage.show(device));
  }
  
  go() {
    _router.listen();
  }
  
  final _router = new Router(useFragment:true);
}
