// Copyright (c) 2013, the project authors. Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed 
// by a Apache license that can be found in the LICENSE file.

part of handheld_sample;

abstract class Page {
  static Element _header, _page;
  
  Page(this._router, {this.pageTitle, this.showBackButton:true}) {
    if(_header == null) {
      _header = query("#header");
    }
    if(_page == null) {
      _page = query("#page");
    }
  }
  
  show(Device device) {
    document.body.style.display = 'none';
    // TODO transition with frame
    _showHeader();
    _showTitle();
    _showPageContent(_page, device);
    document.body.style.display = 'block';
  }
  
  _showHeader() {
    _header.innerHtml = ''' 
      <h2 id="title">$pageTitle</h2>
      <button id="main" style="display: none;">home</button>
    ''';
    if(showBackButton) {
      var backButton = _header.query('#main');
      backButton.style.display = 'block';
      backButton.onClick.listen((MouseEvent evt) => navigateTo(backButton.id));
    } 
  }
  
  _showTitle() {
    (window.document as HtmlDocument).title = pageTitle;
  }
  
  _showPageContent(Element page, Device device);
  
  navigateTo(String id) => _router.gotoPath("#${id}", "");
  
  final String pageTitle;
  final bool showBackButton;
  final Router _router;
}

