// Copyright (c) 2013, the project authors. Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed 
// by a Apache license that can be found in the LICENSE file.

part of handheld;

/** Provides access to the device's default camera application. */
abstract class DeviceCamera {
  /** Get URI to photo taken from devices camera or image gallery */
  Future<Uri> getPictureUri({
    int quality, 
    PictureSourceType sourceType,
    bool allowEdit,
    int targetWidth,
    int targetHeight,
    bool saveToPhotoAlbum});
  
  /** Get photo as base 64 encoded string from devices camera or image gallery */
  Future<String> getPictureData({
    int quality, 
    PictureSourceType sourceType,
    bool allowEdit,
    int targetWidth,
    int targetHeight,
    bool saveToPhotoAlbum});
  
  /** Removes intermediate photos taken by the camera from temporary storage */
  Future<bool> cleanup();
}

class PictureSourceType {
  const PictureSourceType();
  
  static const CAMERA = const PictureSourceType();
  static const PHOTOLIBRARY = const PictureSourceType();
  static const SAVEDPHOTOALBUM = const PictureSourceType();
}