// Copyright (c) 2013, the project authors. Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed 
// by a Apache license that can be found in the LICENSE file.

library handheld_mock_impl;

import 'dart:async';

import 'package:log4dart/log4dart.dart';
import 'package:meta/meta.dart';

import 'handheld_api.dart';

part 'mock/device_mock.dart';
part 'mock/device_camera_mock.dart';
part 'mock/device_accelerometer_mock.dart';
part 'mock/device_notification_mock.dart';

class HandheldMock implements Handheld {
  factory HandheldMock() {
    if(_instance == null) {
      _instance = new HandheldMock._internal();
    }
    return _instance;
  }

  HandheldMock._internal();
  
  @override
  Future<Device> get onDeviceReady {
    if(_device == null) {
      _device = new DeviceMock();
    } 
    return new Future.value(_device);
  }
  
  Device _device;
  static Handheld _instance;
  static final _logger = LoggerFactory.getLoggerFor(HandheldMock);
}




